﻿
Imports System.Management
Imports System.IO.Ports
Imports System.Text.RegularExpressions

Public Class Form1
    Public Opened As Integer
    Private Sub btnOpen_Close_Click(sender As Object, e As EventArgs) Handles btnOpen_Close.Click

        If btnOpen_Close.Text = "OPEN" Then
            'Port number assgin
            Dim matche As Object = New Regex("\((.+?)\)").Matches(cmbAddress.Text)
            Dim portAddress As String = matche(0).Value.Trim("("c, ")"c)

            Try
                Opened = 1
                Cursor.Current = Cursors.WaitCursor
                ' Device Open and Init
                SerialPort1.PortName = portAddress
                SerialPort1.BaudRate = Int32.Parse(cmbBaud.Text)
                SerialPort1.DataBits = 8
                SerialPort1.StopBits = System.IO.Ports.StopBits.One
                SerialPort1.Parity = System.IO.Ports.Parity.None
                SerialPort1.Handshake = System.IO.Ports.Handshake.None
                SerialPort1.Open()
                SerialPort1.DiscardInBuffer()

                SerialPort1.WriteLine("*cls")
                txtSendMsg.Text = "*idn?"

                ' Set form
                btnOpen_Close.Text = "CLOSE"
                btnSend.Enabled = True
                btnRead.Enabled = True
                cmbAddress.Enabled = False
                cmbBaud.Enabled = False
                btnRefesh.Enabled = False

            Catch ex As Exception
                MessageBox.Show(ex.Message)

            Finally
                Cursor.Current = Cursors.Default
            End Try
        Else
            Try
                ' Device Close
                SerialPort1.WriteLine("*cls")
                System.Threading.Thread.Sleep(200)
                SerialPort1.Close()

                ' Set form
                btnOpen_Close.Text = "OPEN"
                txtReadMsg.Text = ""
                btnSend.Enabled = False
                btnRead.Enabled = False
                cmbAddress.Enabled = True
                btnRefesh.Enabled = True
                cmbBaud.Enabled = True
                Opened = 0

            Catch ex As Exception
                MessageBox.Show(ex.Message)
            End Try
        End If
    End Sub


    Private Sub btnSend_Click(sender As Object, e As EventArgs) Handles btnSend.Click
        Dim SendMsg As String = ""

        SendMsg = txtSendMsg.Text
        Try
            txtReadMsg.Text = ""
            SerialPort1.WriteLine(SendMsg)

            If SendMsg.IndexOf("?") >= 0 Then
                System.Threading.Thread.Sleep(200)
                btn_Read()
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub btnRead_Click(sender As Object, e As EventArgs) Handles btnRead.Click
        btn_Read()
    End Sub

    Private Sub btnRefesh_Click(sender As Object, e As EventArgs) Handles btnRefesh.Click
        refresh_com()
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Opened = 0
        refresh_com()
        cmbBaud.Items.Add("9600")
        cmbBaud.Items.Add("19200")
        cmbBaud.Items.Add("38400")
        cmbBaud.Items.Add("57600")
        cmbBaud.Items.Add("115200")
        cmbBaud.SelectedIndex = 0

        '// Set form
        btnOpen_Close.Text = "OPEN"
        txtSendMsg.Text = "*idn?"
        btnRefesh.Enabled = True

    End Sub

    ' Rescan comport
    Private Sub refresh_com()

        cmbAddress.Items.Clear()
        cmbAddress.Text = ""

        '   //Port description  FTDIOK 
        Dim CheckComNum As Object = New System.Text.RegularExpressions.Regex("COM[1-9][0-9]?[0-9]?")
        Dim mcPnPEntity As System.Management.ManagementClass = New System.Management.ManagementClass("Win32_PnPEntity")
        Dim manageObjCol As System.Management.ManagementObjectCollection = mcPnPEntity.GetInstances()
        Dim manageObj As System.Management.ManagementObject
        For Each manageObj In manageObjCol
            Dim namePropertyValue As Object = manageObj.GetPropertyValue("Name")
            If namePropertyValue Is Nothing Then
                Continue For
            End If

            Dim name As String = namePropertyValue.ToString()
            If CheckComNum.IsMatch(name) Then
                cmbAddress.Items.Add(name)
            End If
        Next
        If cmbAddress.Items.Count > 0 Then
            cmbAddress.SelectedIndex = 0
        End If

    End Sub

    Private Sub btn_Read()

        Try
            Cursor.Current = Cursors.WaitCursor
            txtReadMsg.Text = SerialPort1.ReadExisting() + vbCrLf

        Catch ex As Exception
            MessageBox.Show(ex.Message)

        Finally
            Cursor.Current = Cursors.Default
        End Try
    End Sub

End Class
